#include        "ksysdefs.h"
#include        "ksysvtyp.h"
#include        "kawkdefs.h"
/**/
#include		"ksysprot.h"
#include		"kawkfunc.h"
static  char    *txt = NULL;
/*
**      routines that use memory blocks are gathered
**      here for debugging.
*/
void
formzero()	/* free memory on interrupts */
{
	setwork(16);
	clrsym();
	txt = free_if(txt);
}
char    *
formcomp(is,ex)     /* COMPILE THE FORMAT FILE */
char    *is;        /* FORMAT FILE */
char    *ex;        /* EXPRESSION */
{
    REG         char    *pgs = NULL;
    REG         char    *lst = NULL;
/*      clear symbol table */
    clrsym();
	txt = free_if(txt);
/*      read in program text */
    if(is)  lpxsetr(txt = pgs = blkrd(is));
    else
    if(ex)  lpxsetr(pgs = ex);
    else    {
        errmsg("formcomp <no file, no expression>\n");
        terror(FUBAR);
        }
/*  INITIALIZE LINE NUMBERING */
    linesetr(1);
	lexset(0);
	brackset(0);
/*  INITIALIZE CODE POINTER */
    setcode(0);
/*  COMPILE CODE */
    addcode( (FUNCP) xstart,"xstart");
/**/
    while((int) (lst != pgs) && pgs &&
			(int) (pgs = skipbs(pgs)) && *pgs != ZERO)	{
        pgs = statecomp(lst = pgs);
		}
/**/
    if(lst && lst == pgs)   {
        errptr(pgs,"formcomp <syntax error>");
        }
    addcode(XSTOP,"XSTOP");
    addcode(XSTOP,"XSTOP");
    addcode(XSTOP,"XSTOP");
/**/
	txt = free_if(txt);
/**/
	linesetr(1);
/**/
    return(NULL);
}
char    *
formexec(is,es)
char    *is;        /* format file */
char    *es;        /* expression */
{
    zerocount();        /* zero input count */
    zerofile();         /* zero file count */
	setofn(NULL,NULL);	/* return to stdout */
    setwork(16);        /* reduce while compiling */
    formcomp(is,es);    /* compile */
    esetr((DATUM *) NULL);        /* reset stack */
    setwork(BLKSIZ);    /* set default work area */
    xstart();           /* start execution */
	setofn(NULL,NULL);	/* close any open output files */
    return(NULL);
}
