#include	<stdio.h>
#include	<ctype.h>
/*TYPEDEF*/
typedef	struct	KEYWORD	{
	char	*kname;
	char	ksize;
	char	level;
	}	KEYWORD;
/*EXTERN*/
extern	char	*skipbs(char *);
extern	char	*compile(char *);
extern	int		system(char *);
extern	char	*getword(char *, char *, char *);
extern	char	*getoper(char *);
extern	char	*getword(char *, char *, char *);
/*GLOBAL*/
KEYWORD	keyword[] = {
	"%",	1,
	"/",	1,
	"*",	1,
	"-",	1,
	"+",	1,
	"!=",	2,
	"==",	2,
	":",	1,
	"?",	1,
	"=",	1,
	NULL,	0,
	}	;
char	ls[BUFSIZ];
main()
{
	while(putchar('?'),fflush(stdout),gets(ls))
	switch(ls[0])	{
		case	'!':	system(ls+1);break;
		default:		compile(ls);break;
		}
}
char	*
getoper(is)
char	*is;
{
	auto	KEYWORD	*kwx = keyword;
	while(kwx->kname)	{
		if(strncmp(is,kwx->kname,kwx->ksize) == 0)	{
fprintf(stderr,"getoper: kname(%s)\n",kwx->kname);
			return(is+kwx->ksize);
			}
		kwx += 1;
		}
	return(NULL);
}
char	*
getword(os,us,is)
char	*os;
char	*us;
char	*is;
{
	auto	char	*osx = os;
	while(os < us  && (isalnum(*is) || *is == '_'))	*os++ = *is++;
	*os = 0;
fprintf(stderr,"getword: osx(%s)\n",osx);
	return(is);
}
char	*
compile(is)
char	*is;
{
	auto	char	word[32];
	auto	char	*os = NULL;
	while(is && os != is && (os = is = skipbs(is)))	{
/*fprintf(stderr,"compile: is(%s)\n",is);*/
		if(isalpha(*is))	is = getword(word,word+32,is);
		else				is = getoper(is);
	}
	return(is);
}
char	*
skipbs(is)
char	*is;
{
	while(isspace(*is))	++is;
	return(is);
}
