/*
	89:02:14 rewritten to use one large array for both data and
	pointers to it.  this reduced time from 27 to 19 seconds for
	the test file.  ain't i clever.
	89:02:20 data array modified to take advantage of Sun memory
*/
#define		DEBUG
#undef		DEBUG
#define		WARN_NULLS
#include	"ksysdefs.h"
#include	"ksysvtyp.h"
#include	"ksysprot.h"
#include	<signal.h>
/**/
#define		W_OPEN		1
#define		W_CLOSE		2
#define		W_PASS		4
#define		CMASK		'\137'
#define		UPPR		'\177'
#define		LOWR		ZERO
#ifndef		__TURBOC__
#define		STRICMP		/* include ignore case strcmp */
#endif
/**/
typedef	struct		DICT	{
	char		*data;	/* where we record words */
	char		*base;	/* base of recording array */
	char		**line;	/* where we record lines */
	unsigned	numl;	/* number of lines */
	unsigned	size;	/* size of data area (original) */
	}	DICT;
DICT	dict;
/*EXTERN*/
#ifdef	CAN_PROTO
extern void dumpdict(FILE *);
extern NOSIGN dumperrs(void);
extern int hint(int);
extern void makedict(NOSIGN);
extern void makework(int);
extern int newcmp(char * *,char * *);
extern int savedict(char *);
extern void showerrs(NOSIGN,char *);
extern void terror(int);
extern long xlist(char *,char *);
#else	/*CAN_PROTO*/
extern void dumpdict();
extern NOSIGN dumperrs();
extern int hint();
extern void makedict();
extern void makework();
extern int newcmp();
extern int savedict();
extern void showerrs();
extern void terror();
extern long xlist();
#endif	/*CAN_PROTO*/
/*GLOBAL*/
char	*rm = "r";
char	*wm = "w";
KENV	kenv;
NOSIGN	needsort;
char	*crap[1];
char	*shit[1];
char	*tmpdir;		/* temporary directory for work files */
NOSIGN	cycle;			/* error check cycle */
NOSIGN	ndata;			/* number of data points */
NOSIGN	nblok;			/* number of data blocks */
long	nerr;			/* number of errors passed */
long	nchk;			/* words checked */
long	dcnt;			/* dictionary word count */
char	dfn[FNMSIZ];	/* dictionary file name */
FILE	*dfp;			/* dictionary file pointer */
char	efn[FNMSIZ];	/* error file name */
FILE	*efp;			/* error file pointer */
char	*efb;			/* error buffer */
char	wfn[FNMSIZ];	/* work file name */
char	*wfb;			/* work file buffer */
FILE	*wfp;			/* work file pointer */
char	*dfb;			/* dictionary buffer */
char	last[FNMSIZ];	/* last word */
char	*ofn;
char	ls[FNMSIZ];
char	zs[FNMSIZ];
char	ps[FNMSIZ];
int		upper = 1;		/* upper case processing switch */
/**/
hint(ty)
int		ty;
{
static	char	*hx[] = {
"=wordlist [-options] [-d dictionary] [-e error_list]",
"*",
"*       check a list of suspected spelling errors against a",
"*       dictionary list.",
"*",
"*       this program is used by kspell.",
"*",
"=OPTIONS",
"-vNN    verbosity level",
"-iNN    ignore case as indicated below",
"-i1     map dictionary to lower case",
"-i2     map error list to lower case",
"-i3     map both dictionary and error list to lower case",
"-r      reverse the comparison (see below)",
"=",
"~",
"=USAGE",
"*",
"*       dictionary and error lists should be one word per line",
"*       with no leading blanks.",
"*",
"*       either the dictionary OR the error_list file may come from",
"*       the standard input, but one of the two files must be",
"*       specified.",
"*",
"*       this program may also be used to compare any two lists",
"*       provided no one line is longer than 128 charcters.",
"*",
"*       wordlist -d list_1 -e list_2",
"*           will show all items from list_2 that are NOT in",
"*           list_1",
"*",
"*       wordlist -r -d list_1 -e list_2",
"*           will show all items from list_2 that ARE in",
"*           list_1",
"*",
"=",
"~",
	}	;
	prhint(hx,sizeof(hx)/sizeof(char**),NULL,ZERO);
	return(ty);
}
void
terror(ty)
int		ty;
{
	makework(W_PASS);
	exit(ty);
}
main(argc,argv)
int		argc;
char	*argv[];
{
/*	
set stdout buffer, reserve heap space for other buffers
*/
	setbuf(stdout,emalloc(bufsiz(),"main: stdout"));
	efb = emalloc(bufsiz(),"main: efb");
	dfb = emalloc(bufsiz(),"main: dfb");
	wfb = emalloc(bufsiz(),"main: wfb");
/**/
	kenv.dosdos = isdos();
	disnme(kenv.pname = "wordlist");
/**/
	if(kenv.dosdos)	cmdxpd(argc,argv);
	else			telluser(kenv.pname);
/**/
	disrec(cmdnum(argc,argv,'R',1,0));
/**/
	if(cmdnum(argc,argv,'h',0,1))	{
		if(isatty(1))	{
			kenv.leisur = DA | DB;
			whoru(stdout);
			query(stdout);
			}
		exit(hint(0));
		}
/**/
	kenv.flags0 = cmdnum(argc,argv,'i',0,DA);
	kenv.flags1 = cmdnum(argc,argv,'r',0,DA);
/**/
	kenv.report = cmdnum(argc,argv,'v',DA,DA|DB);
/**/
	tmpdir = cmdstr(argc,argv,'T',kgetenv("TMPDIR"));
	if(isnull(tmpdir))	{
		if(kenv.dosdos)	tmpdir = ".";
		else			tmpdir = "/usr/tmp";
		}
	tmpdir = strsave(tmpdir);
/**/
	{
	auto	char	*xdfn;
	auto	char	*xefn;
	xdfn = cmdstr(argc,argv,'d',NULL);
	xefn = cmdstr(argc,argv,'e',NULL);
	if(!xefn && !xdfn)	{
		errmsg("<missing file names>\n");
		exit(FUBAR);
		}
	if(xdfn)	strcpy(dfn,xdfn);
	if(xefn)	strcpy(efn,xefn);
	}
/**/
	ofn = cmdstr(argc,argv,'o',NULL);
	if(ofn)	{
		freopen(ofn,kenv.dosdos ? "wb" : "w",stdout);
		}
/**/
	if(signal(SIGINT,SIG_DFL) != SIG_IGN)	{
		setcbrk(YES);
		signal(SIGINT,terror);
		}
/**/
	makedict(  1 );
/**/
	xlist(dfn,efn);
/**/
	dumperrs();
/**/
	exit(0);
	return(0);
}
long
xlist(os,is)
char	*os;		/* dictionary */
char	*is;		/* errors */
{
/**/
	auto	char	*ls = emalloc(FNMSIZ,"xlist:ls");
/**/
	auto	int		lc = 0;
/**/
	if(isnull(os))	dfp = stdin;
	else			dfp = tefopen(os,rm);
/**/
	setbuf(dfp,dfb);
/**/
	if(kenv.report & DA)	prwho(" reading dictionary\n");
/**/
	while(fgetls(ls,ls+FNMSIZ-1,dfp))	{
/**/
		if(kenv.flags0 & DA)	strlwr(ls);
/**/
		if(ls[0] < lc)	needsort = 1;
		lc = ls[0];
/**/
		while(1)	{
			if(savedict(ls))	{
				/* dumpdict(stderr); */
				showerrs(dict.numl,"read loop");
				makedict( 1 );
				}
			else	break;
			}
/**/
	dcnt += 1;
	}
/**/
	showerrs(dict.numl,"end of dictionary");
	makedict( 0 );
/**/
	if(kenv.report & DA)	prwho(" %ld words from dictionary\n",dcnt);
/**/
	ls = free_if(ls);	/* must be local */
	return(dcnt);
}
void
showerrs(ndata,is)
NOSIGN	ndata;
char	*is;
{
	auto	char	**bs;		/* this must be char **/
	auto	long	errs_rd = 0L;
	auto	long	errs_wr = 0L;
	auto	long	errs_cx = 0L;
/**/
	if(needsort)	{
		qsort(dict.base,dict.numl,sizeof(char *),newcmp);
		needsort = 0;
		}
/**/
	makework(W_OPEN);
/**/
	if(kenv.report & DB)
		prwho(" input from %s to %s\n",
			isnull(efn) ? "stdin" : efn,wfn);
/**/
	if(isnull(efn))	efp = stdin;
	else			efp = tefopen(efn,rm);
	setbuf(efp,efb);
/**/
	ls[0] = ps[0] = ZERO;
/**/
	while(fgetls(ls,ls+FNMSIZ-1,efp))	{
/**/
		if(kenv.flags0 & DB)	strlwr(ls);
/**/
		shit[0] = ls;	/* to fool bsearch: VERY IMPORTANT */
/**/
		errs_rd += 1;
		if(strcmp(ps,ls) != 0)	{	/* skip duplicates */
/**/
		nchk += 1;
/*
CTEXT:	note carefully the cast on bsearch and the type of bs.
*/
		if(islower(ls[0]))	{
		bs = (char **) bsearch(shit,dict.base,dict.numl,sizeof(char *),newcmp);
			}
		else	{
		bs = (char **) bsearch(shit,dict.base,dict.numl,sizeof(char *),newcmp);
			if(bs == (char **) NULL)	{
				strcpy(zs,ls);
				strlwr(zs);
				crap[0] = zs;
		bs = (char **) bsearch(crap,dict.base,dict.numl,sizeof(char *),newcmp);
				}
			}
/*
	should be some way of doing case without having to copy and
	compare again.
*/
		if(kenv.flags1 & DA)		{
			bs = (bs == (char **) NULL) ? shit : (char **) NULL;
			}
/**/
		if(bs == (char **) NULL)	{	/* not found */
#ifdef	DEBUGR
	fprintf(stderr,"ls(%s)\n",ls);
#endif
			fputs(ls,wfp);
			fputs("\n",wfp);
			nerr += 1;
			errs_wr += 1;
			}
		}
	strcpy(ps,ls);
	}
/**/
	if(kenv.report & DB)
		prwho(" read %ld, passed %ld:%ld from %s to %s\n",
			errs_rd,errs_wr,errs_cx,isnull(efn) ? "stdin" : efn,wfn);
/**/
	makework(W_CLOSE);
	makework(W_PASS);
/**/
	return;
}
newcmp(os,is)
char	**os;		/* key */
char	**is;		/* datum */
{
	auto	int		ret;
#ifdef	DEBUGR
	fprintf(stderr,"newcmp(%s,%s)\n",*os,*is);
#endif
	ret = **os - **is;
	if(ret == 0) 	return(strcmp(*os,*is));
	else			return( ret );
}
void
makework(ty)
int		ty;
{
	if(ty & W_PASS)		{
		if(cycle++)	unlink(efn);
		strcpy(efn,wfn);
		wfn[0] = ZERO;
		}
	if(ty & W_CLOSE)	{
		wfp = xfclose(wfp);
		}
	if(ty & W_OPEN)	{
		strcpy(wfn,tmpdir);
		strcat(wfn,"/");
		strcat(wfn,"wlXXXXXX.tmp");
		maketemp(wfn);
		if(!(wfp = efopen(wfn,kenv.dosdos ? "wb" : "w")))
			terror(FUBAR);
		setbuf(wfp,wfb);
		}
	return;
}
NOSIGN
dumperrs()
{
	auto	NOSIGN	ecnt = 0;
	if(kenv.report & DB && !isnull(efn))
		prwho(" dump file is %s\n",efn);
/**/
	if(isnull(efn))	efp = stdin;
	else			efp = tefopen(efn,rm);
	setbuf(efp,efb);
/**/
	while(fgetls(ls,ls+FNMSIZ-1,efp))	{
		ecnt += 1;
		puts(ls);
		}
/**/
	xfclose(efp);
	makework(W_PASS);
/**/
	return(ecnt);
}
savedict(is)
char	*is;
{
	auto	unsigned	ls = strlen(is) + 1;
	dict.data -= ls;
	if((char *) dict.line >= dict.data)	return(1);	/* full */
	*dict.line++ = strcpy(dict.data,is);
	dict.numl += 1;
	return(0);
}
void
makedict(nc)
unsigned	nc;
{
	dict.base = dict.data = free_if(dict.base);
	dict.line = (char **) NULL;
	dict.numl = dict.size = 0;
	if(nc)	{
		auto	long		meminc;
		auto	long		maxmem;
		if(sizeof(char *) == 2)	maxmem = 1L << 16;
		else
		if(sizeof(char *) == 4)	maxmem = 1L << 20;
		else					abort();
		nc = meminc = maxmem / 8;
		while(nc <= maxmem)	{
			dict.base = malloc((unsigned) nc);
			if(dict.base != NULL)	{
				nc += meminc;
				free(dict.base);
				continue;
				}
			else	break;
		}
/**/
		if(dict.base)	free(dict.base);
		nc -= meminc;
		dict.base = emalloc(nc,"makedict");
		dict.data = dict.base + nc;
		dict.line = (char **) dict.base;
		dict.size = nc;
		if(kenv.report & DB)	{
			prwho("makedict <core> %u\n",dict.size);
			}
		}
	return;
}
void
dumpdict(fp)
FILE	*fp;
{
	register	char	**osx = (char **) dict.base;
	register	char	**usx = (char **) dict.line;
	while(osx < usx)	{
		fputs(*osx++,fp);
		fputs("\n",fp);
		}
	makedict( 1 );
	return;
}
