#include	"ktheader.h"
/**/
char	**
getstring(argv)
char	**argv;
{
	strxty(*argv,'\'',ZERO);
	prx++->string = *argv;
	return(argv+1);
}
char	**
gettype(argv)
char	**argv;
{
	auto	NOSIGN	type = 0;
	auto	NOSIGN	nsel = 0;
	auto	char	*is = *argv;
	while(*is != 0) switch(*is++) {
	case	'b':	type |= S_IFBLK;nsel++;break;
	case	'c':	type |= S_IFCHR;nsel++;break;
	case	'd':	type |= S_IFDIR;nsel++;break;
	case	'f':	type |= S_IFREG;nsel++;break;
#ifdef	S_IFIFO
	case	'p':	type |= S_IFIFO;nsel++;break;
#endif	/*S_IFIFO*/
	default:
		errmsg("gettype <unknown file type> '%c'\n",is[-1]);
		terror(FUBAR);
	}
	if(nsel > 1)	{
		errmsg("gettype <too many types with -type [bcdfp]>\n");
		terror(FUBAR);
		}
	prx++->value = type;
	return(argv+1);
}
getdir(argc,argv)
int		argc;
char	*argv[];
{
	auto	int		ix;
	ndir = ZERO;
	for(ix = 1; ndir < NDIR && ix < argc; ix++)	{
		if(argv[ix] == NULL)				continue;
		if(*argv[ix] == '-')	break;
		if(*argv[ix] == '(')	break;
		if(*argv[ix] == '!')	break;
		dlist[ndir++] = argv[ix];
		argv[ix] = NULL;
		}
	if(ndir >= NDIR)	{
		errmsg("getdir <too many names>\n");
		terror(FUBAR);
		}
	if(ndir == 0)		{
		errmsg("getdir <no file or directory>\n");
		terror(FUBAR);
		}
	return(ndir);
}
char	**
getcmd(argv)
char	**argv;
{
	auto	char	*cmx = cmd;
	auto	char	*cmu = cmd + FNMSIZ - 1;
	while(argv < argu)	{
		if(**argv == ';')	{
			prx++->string = strsave(cmd);
			return(argv += 1);
			}
		else							{
			cmx = strkat(cmx,cmu,*argv);
			cmx = strkat(cmx,cmu," ");
			argv += 1;
			}
		}
	*cmx++ = ZERO;
	if(cmx >= cmu)	{
		errmsg("getcmd <-exec or -ok command too long>\n");
		terror(FUBAR);
		}
	errmsg("getcmd <-exec or -ok not terminated>\n");
	terror(FUBAR);
	return( (char **) NULL);
}
char	**
getfunc(argv)		/* select numerical comparison */
char	**argv;
{
	auto	char	*is = *argv;
	if(*is == '-')	{ prx++->func = lessthan; ++is; }
	else
	if(*is == '+')	{ prx++->func = morethan; ++is; }
	else			prx++->func = equalto;
	prx++->value = atol(is);
	return(argv += 1);
}
char	**
getnewer(argv)
char	**argv;
{
	auto	char	*is = *argv;
	auto	long	mt = 0L;
/**/
	if(stat(is,&sbuf) < 0)	{
		prwho(" <does not exist> '%s'\n",is);
		}
	else	mt = sbuf.st_mtime;
/**/
	prx++->value = mt;
	return(argv += 1);
}
TREE	*
intree(is)
char	*is;
{
/*	CASE	*/
	REG		TREE	*tx = tree;
	REG		char	*os;
	while(tx->sig != NULL)	{
		os = tx->sig;
		if(is[0] == os[0] &&
			is[1] == os[1] &&
				is[2] == os[2])	return(tx);
		tx += 1;
		}
	return( (TREE *) NULL);
}
char	**
getoct(argv)
char	**argv;
{
	auto	char	*is = *argv;
	sscanf(is,"%lo",&prx++->value);
	return(argv += 1);
}
char	**
getid(argv)
char	**argv;
{
	auto	char	*is = *argv;
	sscanf(is,"%lu",&prx++->value);
	return(argv += 1);
}
