#include    "ksysdefs.h"
#include    "ksysvtyp.h"
/**/
#include    "kawkdefs.h"
#include	"ksysprot.h"
#include	"keyproto.h"
#include	"kawkfunc.h"
/**/
/*EXTERN*/
/*STATIC*/
static	int	loop = 1;
void
zds(is)
char	*is;
{
	doshell(is,rfn,keysget());
}
void
zkh(is)
char	*is;
{
	khint("kawk",is);
}
void
zsa(is)
char	*is;
{
	kenv.talarm = atoi(is);
}
void
xcd(is)
char	*is;
{
	if(kchdir(is) < 0)	terror(FUBAR);
}
void
xcc()
{
	formcomp(formnull(),NULL);
}
void
xdd(is)
char	*is;
{
	if(!isnull(is))	 kenv.diagno = atoi(is);
	printff("diagnostic level = %d\n",kenv.diagno);
}
void
xerr(is)
char	*is;
{
	fputs(getlerr(),stderr);
}
void
xsf(is)
char	*is;
{
	setfold(atoi(is));
}
void
xff(is)
char	*is;
{
	formfile(is);
}
void
xgo()
{
    formexec(formnull(),NULL);
}
void
xdohtwo(is)
char	*is;
{
    doshell(strcpy(is,"ksysdoc kawk"),NULL,NULL);
}
void
xdohone(is)
char	*is;
{
    doshell(strcpy(is,"kawk -h"),NULL,NULL);
}
void
xwhat(is)
char	*is;
{
	whatkey(is);
}
void
xdolone(is)
char	*is;
{
    strcpy(is,"more %");
	doshell(is,ffn,NULL);
}
void
xdoltwo(is)
char	*is;
{
    strcpy(is,"more #");
	doshell(is,NULL,infile(0));
}
void
xsp(is)
char	*is;
{
	setcode(atoi(is));
}
void
xqu()
{
	loop = 0;
}
void
xss(is)
char	*is;
{
    kenv.screen = atoi(is);
	kenv.leisur = kenv.screen;
	kenv.slines = 0;
}
void
xrs(is)
char	*is;
{
	kenv.report = atoi(is);
}
void
xtf(is)
char	*is;
{
    termfile(is);
}
void
xti()
{
    kenv.timing = !kenv.timing;
}
void
xte()
{
    terror(FUBAR);
}
void
xek(is)
char	*is;
{
    strcpy(is,"ex +1 #");
	doshell(is,NULL,infile(0));
}
void
xex(is)
char	*is;
{
    sprintf(is,"ex +%d %%",lineretr());
	doshell(is,ffn,NULL);
}
void
xvk(is)
char	*is;
{
    strcpy(is,"vi +1 #");
	doshell(is,NULL,infile(0));
}
void
xsu(is)
char	*is;
{
	setuser(is);
}
void
xvv(is)
char	*is;
{
    sprintf(is,"vi +%d %%",lineretr());
#ifdef	DEBUG
	fprintf(stderr,"xvv(%s)\n",is);
	if(query(stderr) == 'q')	terror(FUBAR);
#endif
	doshell(is,ffn,NULL);
}
/**/
typedef	struct	COMMAND	{
	char	*kcs;		/* command string */
	int		kcl;		/* command length */
	FUNCP	kfx;	/* command function */
	}	COMMAND	;
COMMAND	kcmd[] = {
		"!",1,(FUNCP) zds,
		"?",1,(FUNCP) zkh,
		"A",2,(FUNCP) zsa,
		"C",1,(FUNCP) xsp,
		"D",1,(FUNCP) xdd,
		"E",1,(FUNCP) xerr,
		"F",1,(FUNCP) xsf,
		"H",1,(FUNCP) xdohtwo,
		"L",1,(FUNCP) xdoltwo,
		"Q",1,(FUNCP) xqu,
		"R",1,(FUNCP) xrs,
		"S",1,(FUNCP) xss,
		"T",1,(FUNCP) xte,
		"V",1,(FUNCP) xvk,
		"X",1,(FUNCP) xek,
		"cd",2,(FUNCP) xcd,
		"c",1,(FUNCP) xcc,
		"f",1,(FUNCP) xff,
		"g",1,(FUNCP) xgo,
		"h",1,(FUNCP) xdohone,
		"k",1,(FUNCP) xwhat,
		"l",1,(FUNCP) xdolone,
		"q",1,(FUNCP) xqu,
		"r",1,(FUNCP) xtf,
		"t",1,(FUNCP) xti,
		"u",1,(FUNCP) xsu,
		"v",1,(FUNCP) xvv,
		"x",1,(FUNCP) xex,
	}	;
static	int	ncmd = sizeof(kcmd)/sizeof(COMMAND);
/**/
tgetcmd()
{
	static	char	ls[BLKSIZ];
	auto	char	*lsx;
	auto	FUNCP	kfx = (FUNCP) NULL;
	REG		COMMAND	*kmx = kcmd;
	REG		COMMAND	*kmu = kcmd + ncmd;
/**/
    if(kenv.timing) timer();
/**/
	while(loop)	{
/**/
	printff("(%s)=>",kenv.pname);
/**/
	if(!fgetlf(lsx = ls,ls+BLKSIZ-1,stdin))	{
	while(isspace(*lsx))	++lsx;
/**/
	if(isatty(0))	{
		errmsg("<use q to quit>\n");
		clearerr(stdin);
		continue;
		}
	else	terror(FUBAR);
	}
/**/
    if(hascntrl(lsx))    continue;
/**/
	kfx = (FUNCP) NULL;
/**/
	kmx = kcmd;
	while(kmx < kmu)	{
		if(strncmp(lsx,kmx->kcs,kmx->kcl) == 0)	{
			kfx = kmx->kfx;
			break;
			}
		kmx += 1;
		}
/**/
	if(kfx != (FUNCP) NULL)	{
		(*kfx)(strcnd(lsx + kmx->kcl));
		}
	else	{
		errmsg("tgetcmd <unknown command> '%c'\n",lsx[0]);
		}
/**/
	}
	return('q');
}
void
whatkey(is)
char	*is;
{
	if(isnull(is))	{
		if(kenv.keying)	keyslist();
		else			errmsg("<not keying>\n");
		}
	else			{
		keysread(keysfile(is));
		}
	return;
}

