/*
	this is an interface between ked and other programs that
	call vi where vi is actually a public domain clone.  this
	interface adjusts the Bibliofile calling sequence to that
	expected by the clone.
*/
/*DOSLIB*/
#include	<stdio.h>
#include	<io.h>
#include	<stdlib.h>
#include	<process.h>
#include	<string.h>
extern void message(char *);
main(argc,argv)
int		argc;
char	*argv[];
{
	auto	char	*freevi = getenv("FREEVI");
	if(!freevi)
		message("\007<need FREEVI in environment>\n");
	if(access(freevi,05))
		message("\007<cannot access named FREEVI>\n");
	if(argc > 3)
		message("\007<incorrect number of arguments>\n");
	if(*argv[1] == '+') execl(freevi,"vi",argv[2],NULL);
	else
	if(*argv[1] == '-') execl(freevi,"vi",argv[2],NULL);
	else 				execl(freevi,"vi",argv[1],NULL);
	message("\007<exec failed>\n");
	exit(69);
}
void
message(is)
char	*is;
{
	auto	char	*msg;
	msg = "USAGE: govi +1 file\n";
	write(2,msg,strlen(msg));
	msg = "govi calls the editor named by FREEVI\n";
	write(2,msg,strlen(msg));
	msg = "FREEVI=exact_pathname must be in the environment\n";
	write(2,msg,strlen(msg));
	write(2,is,strlen(is));
	exit(69);
}
