#define		NEWCODE
/*DOSLIB*/
#include	"ksysdefs.h"
#include	"ksysvtyp.h"
#include	"ksysprot.h"
#include	<dos.h>
#include	<dir.h>
#include	<io.h>
/*EXTERN*/
extern int xlist(int,char **,int (*)());
extern void hint(int);
extern int df(char *);
extern char *megorkilo(long);
extern double longtofloat(long,long);
/**/
KENV		kenv;
void
hint(ty)
int	ty;
{
static	char	*hx[] = {
"=kdf [options] [drive(s)]",
"    report on disk free space",
"=",
"-v	 verbose report",
"=",
}	;
	prhint(hx,sizeof(hx)/sizeof(char**),NULL,ZERO);
	exit(ty);
	return;
}
void
terror(ty)
{
	exit(ty);
}
main(argc,argv)
char	*argv[];
int		argc;
{
	auto	int		ix;
	auto	int		fc = 0;
	disnme(kenv.pname = "kdf");
	kenv.dosdos = isdos();
	if(cmdnum(argc,argv,'h',0,1))		{
		hint(0);
                }
	kenv.flags0 = cmdnum(argc,argv,'v',0,1);
	fc = xlist(argc,argv,df);
	if(fc == 0)				df("C");
	exit(0);
/* ### Warning kdf.c 60: Function should return a value in function main === */
}
xlist(argc,argv,func)
int		argc;
char	*argv[];
int		(*func)();
{
	auto	int		ix;
	auto	int		fc = 0;
	for(ix = 1; ix < argc; ix++)	{
		if(isnull(argv[ix]))	continue;
		else
		if(*argv[ix] == '-')	continue;
		else	{
			fc += 1;
/* ### Warning kdf.c 74: Call to function with no prototype in function xlist === */
			(*func)(argv[ix]);
			}
		}
	return(fc);
}
df(is)
char	*is;
{
	auto	int	drive = *is;
	struct	dfree	dfree;
	auto	long	thave;
	auto	long	tfree;
	auto	long	block;
/* ### Warning kdf.c 88: Void functions may not return a value in function df === */
	if(is[0] == '-')	return(0);
	if(islower(drive))	drive = toupper(drive);
	drive -= '@';
/*
*	TCBUG
*	error message Not an allowed type in function df
*	means if(getdfree(....)) is bad because getdfree returns void
*/
	getdfree((unsigned char ) drive,&dfree);
	if(dfree.df_sclus < 0)	{
		perror(is);
/* ### Warning kdf.c 99: Void functions may not return a value in function df === */
		return(-1);
		}
	tfree = dfree.df_avail;
	tfree *= dfree.df_sclus;
	tfree *= dfree.df_bsec;
	thave = dfree.df_total;
	thave *= dfree.df_sclus;
	thave *= dfree.df_bsec;
	block = tfree / (long) BLKSIZ;
	printf("%c ",drive + '@');
#ifdef	OLDCODE
	printf("total %8ld ",thave);
	printf("used %8ld ",thave - tfree);
	printf("free %8ld ",tfree);
#endif	OLDCODE
#ifdef	NEWCODE
	printf("total %8.8s, ",megorkilo(thave));
	printf("used %8.8s, ",megorkilo(thave - tfree));
	printf("free %8.8s, ",megorkilo(tfree));
#endif	NEWCODE
	printf("blocks %8ld ",block);
	printf("\n");
	if(kenv.flags0)	{
	printf("%c ",drive + '@');
	printf("bytes/sector   %4u  ",dfree.df_bsec);
	printf("sectors/cluster  %4u ",dfree.df_sclus);
	printf("clusters   %4u ",dfree.df_avail);
	printf("\n");
	}
/* ### Warning kdf.c 128: Both return and return of a value used in function df === */
	return(0);
}
char	*
megorkilo(nc)
long	nc;
{
	auto	long	kilo = 1000L;
	auto	long	megs = 1000000L;
	static	char	fs[16];
	if(nc / megs)	sprintf(fs,"%3.1f meg",longtofloat(nc,megs));
	else
	if(nc / kilo)	sprintf(fs,"%3.1f kbs",longtofloat(nc,kilo));
	else			sprintf(fs,"%4d byt",(int) nc);
	return(fs);
}
double
longtofloat(nc,dv)
long	nc;
long	dv;
{
	return((double) nc / (double) dv);
}
