/*DOSLIB*/
#include    "ksysdefs.h"
#include    "ksysvtyp.h"
#include	"ksysprot.h"
/**/
#define         SLINE       BUFSIZ
/**/
/*EXTERNAL*/
extern  char    *doszap();
extern  char    *dosputs();
extern  char    *dospuch();
extern	int		xmore();
/*GLOBAL*/
char    		ls[BUFSIZ];
KENV            kenv;
/**/
more(fp)
FILE    *fp;
{
    auto    int   	lc = 0;
	auto	int		lo = 1;
	auto	NOSIGN	ln = 0;
/**/
    if(kenv.flags1 & DA)                    scr_cl(stdout);
/**/
    while(lo && fgetls(ls,ls+BUFSIZ-1,fp))    	{
/**/
		ln += 1;
/**/
        if((kenv.flags0 & DA) &&
			isblank(ls))   					continue;
/**/
/* ### Warning more.c 33: Call to function 'dosputs' with no prototype in function more === */
        dosputs(ls,ln);
        lc += 1;
/**/
        if(kenv.screen &&
			!(lc % kenv.screen))			{
				if(query(stdout) == 'q')	lo = 0;
				if(kenv.flags1 & DA)        scr_cl(stdout);
/**/
        }
/**/
	}
#ifdef	BARF
	if(!lo && kenv.screen &&
		query(stdout) == 'q')				exit(0);
#endif	BARF
/**/
    return(ZERO);
}
char    *
dosputs(is,ln)
char    *is;
NOSIGN	ln;
{
    REG     char    *isx = is;
	REG		int		pw = ZERO;
/**/
	if(kenv.flags3)	{
		fprintf(stdout,"%4d ",ln);
		pw += 5;
		}
/**/
    while(*isx != ZERO)
    if(*isx == '\n' || *isx == '\r')    break;
	else
	if(*isx == '\t')	{
		auto	int		tabs = pw % kenv.buffer;
		while(tabs++ < kenv.buffer)	{
			putc(' ',stdout);
			pw += 1;
			}
		isx += 1;
		}

    else                                {
		pw += (isprint(*isx)) ? 1 : ((*isx == '\b') ? -1 : 0);
		putc(*isx++,stdout);
		}
	if(kenv.dosdos)	fputs("\r\n",stdout);
	else			fputs("\n",stdout);
	fflush(stdout);
    return(is);
}
void
terror(ty)
{
	exit(ty);
}
main(argc,argv)
int argc;
char    *argv[];
{
    kenv.dosdos = isdos();
	disnme(kenv.pname = "more");
	exit(cmdxrc(argc,argv,xmore,"more.xrc"));
/* ### Warning more.c 97: Function should return a value in function main === */
}
xmore(argc,argv)
int argc;
char    *argv[];
{
/**/
	if(kenv.dosdos)	cmdxpd(argc,argv);
	else			telluser(kenv.pname);
/**/
	disrec(cmdnum(argc,argv,'R',1,0));
/**/
    setbuf(stdout,emalloc(bufsiz(),"main"));
    kenv.leisur = DA | DB;
/**/
    if(cmdnum(argc,argv,'h',0,1))   {
    	if(isatty(1))	whoru(stdout);
    	query(stdout);
/* ### Warning more.c 114: Call to function 'hint' with no prototype in function xmore === */
    	exit(hint(0));
    	}
/**/
    kenv.flags0 = cmdnum(argc,argv,'b',0,DA);
    kenv.flags1 = cmdnum(argc,argv,'p',DA,0);
    kenv.flags2 = cmdnum(argc,argv,'c',0,DA);
    kenv.flags3 = cmdnum(argc,argv,'n',0,DA);
    kenv.screen = cmdnum(argc,argv,'s',22,22);
	{
	auto	char	*tabstop = kgetenv("TABSTOP");
	if(tabstop)	kenv.buffer = atoi(tabstop);
	else		kenv.buffer = 4;
	kenv.buffer = cmdnum(argc,argv,'t',kenv.buffer,kenv.buffer);
	}
    dolist(argc,argv,more);
    fflush(stdout);
    exit(0);
/* ### Warning more.c 131: Function should return a value in function xmore === */
}
hint(ty)
{
static	char	*hx[] = {
"=more [-options] [file(s)]",
"          show text one screen at a time",
"=OPTIONS",
"-p        page mode (1)",
"-b        do not print blank lines",
"-n        line numbers",
"-sNN      screen window (22)",
"-tNN      tab stops at NN (4)",
"-s0       continuous output",
"=PROMPT AND RESPONSES",
"?         next screen?",
"q         quit",
"          [space] next screen",
"=",
"~",
"=EXAMPLES",
"*",
"*         dir | more",
"*",
"*         more chap1.txt chap2.txt chap3.txt",
"*",
"=RELATED PROGRAMS",
"see       display non-ascii characters",
"pager     paginate and display text",
"=MSDOS VERSION",
"          expands wildcards in command line files.",
"=",
}	;
	prhint(hx,sizeof(hx)/sizeof(char**),NULL,ZERO);
    exit(ty);
/* ### Warning more.c 165: Function should return a value in function hint === */
}

