/*DOSLIB*/
/*UNXLIB*/
#define		DEBUG
#include    "ksysdefs.h"
#include    "ksysvtyp.h"
#include	"ksysprot.h"
/**/
#include	<signal.h>
/**/
#define		istext(a)((isspace(a)||isprint(a)) ? 1 : 0)
#define		MASK		0177
/*GLOBAL*/
KENV    kenv;
/*EXTERNAL*/
/**/
#ifdef	CAN_PROTO
extern int alarm(int);
extern int dofile(FILE *);
extern int hint(int);
extern int holdscreen(int);
extern int see(int, char **);
#else
extern int alarm();
extern int dofile();
extern int hint();
extern int holdscreen();
extern int see();
#endif
void
terror(ty)
int		ty;
{
	exit(ty);
}
main(argc,argv)
int     argc;
char    *argv[];
{
    kenv.dosdos = isdos();
    disnme(kenv.pname = "see");
    exit(cmdxrc(argc,argv,see,"see.xrc"));
/* ### Warning see.c 42: Function should return a value in function main === */
}
see(argc,argv)
int     argc;
char    *argv[];
{
/**/
    if(kenv.dosdos) cmdxpd(argc,argv);
    else            telluser(kenv.pname);
/**/
	disrec(cmdnum(argc,argv,'R',1,0));
/**/
    setbuf(stdout,emalloc(bufsiz(),"main"));
/**/
    if(cmdnum(argc,argv,'h',0,1))   exit(hint(0));
/**/
    kenv.screen = cmdnum(argc,argv,'p',isatty(1) * 22,22);
/**/
    kenv.flags1 = cmdnum(argc,argv,'l',0,DA);
    kenv.flags2 = cmdnum(argc,argv,'a',0,DA);
/**/
    kenv.talarm = cmdnum(argc,argv,'t',0,30);
/**/
#ifdef	__TURBOC__
#else
	if(kenv.talarm)	signal(SIGALRM,terror);
#endif
/**/
    kenv.folder = cmdnum(argc,argv,'f',0,56);
/**/
    dolist(argc,argv,dofile);
/**/
    exit(0);
/* ### Warning see.c 74: Function should return a value in function see === */
}
dofile(fp)
FILE    *fp;
{
    REG     int 	lsx;
	REG		int		cc = 0;
    auto    int 	folder = 0;
    auto    int 	lc = ZERO;
/**/
	if(kenv.talarm)	alarm(kenv.talarm);
/**/
    while((lsx = getc(fp)) != EOF)  {
/**/
	if(kenv.talarm && (cc++ % 1000 == 0))	{
		alarm(kenv.talarm);
		cc += 1;
		}
/**/
	if((kenv.flags2 & DC))	lsx &= MASK;
/**/
    if((kenv.flags2 & DA) && !isascii(lsx))     continue;
/**/
    if((kenv.flags2 & DB) && !istext(lsx))      continue;
/**/
    if(lsx == '\n')                 {
        if(kenv.flags1 & DA)            fputs("^J\n",stdout);
        else                    fputs("\n",stdout);
        folder = 0;
        lc += 1;
        holdscreen(lc);
        }
    else
    if(kenv.folder && folder >= kenv.folder)    {
        fputs("\n",stdout);
        folder = 0;
        ungetc(lsx,fp);
        lc += 1;
        holdscreen(lc);
        }
    else
    if(lsx >= ' ' && lsx <= '~')    {
        putc(lsx,stdout);
        folder += 1;
        }
    else
    if(lsx >= 0 && lsx < ' ')       {
        putc('\100',stdout);
        putc(lsx | '\100',stdout);
        folder += 2;
        }
    else
    if(lsx > '~')                   {
        printf("\\%03o",lsx);
        folder += 4;
        }
    }
    return(ZERO);
}
hint(ty)
int ty;
{
static  char    *hx[] = {
"=see [-options] [file(s)] [see.xrc]",
"=DESCRIPTION",
"    converts non-ascii characters to a visible representation",
"    safe for listing to a terminal.  Control characters appear",
"    as @X.  Characters with the high order bit on (0177 and",
"    above) appear in octal notation as \\000.",
"=OPTIONS",
"-a1     show only ascii characters",
"-a2     show only printing ascii characters",
"-a4     force to ascii (strip high bit)",
"-fnn    fold (arbitrarily) long lines at nn characters [off]",
"-l      show line feeds as ^J [off]",
"-p0     screen pause off",
"-p??    screen pause after ?? lines",
"=LIMITS",
"    see reads one character at a time.  Input may be any size.",
"=MSDOS VERSION",
"    expands wild cards in command line file names.",
"=",
}   ;
    prhint(hx,sizeof(hx)/sizeof(char**),NULL,ZERO);
    exit(ty);
/* ### Warning see.c 158: Function should return a value in function hint === */
}
holdscreen(lc)
int     lc;
{
    if(kenv.screen && !(lc % kenv.screen) &&
        query(stdout) == 'q')   exit(0);
    return(0);
}
